CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG ;ALREADY SET BY DOS LOADER
        ORG        100H                        ;SKIP TO END OF THE PSP
ENTPT:        JMP        setres                       ;COM FILE ENTRY ALWAYS AT 100H
; int9.asm is the kbd interrupt handler
;
; THIS STUFF WAS EXTERNAL
istack dw 0
allints dw 256*2 dup(0)
vbuff  dw 0b800h
screen dw 0

extrn  istack:word,allints:word
extrn  vbuff:word,screen:word,getcurs:near,retcurs:near
extrn  printat:near,deskv:byte
extrn  oldints:word,fontsave:byte
;

mode   db  0
old_mode db 0
oint9  dw  0,0
oint10 dw  0,0
public oint9
semaphore db 0
semaphore2 db 0
public semaphore,semaphore2
hshift   db  0ah ; alt left shift
hscan    db  30h ; b character
public hscan,hshift
savess   dw  0
savesp   dw  0
did_pallette db 0
public did_pallette
pallette db 3*257 dup(0)

include fake.asm

set_read:
        mov     al,08h ; bit mask index and all bits
        mov     dx,3ceh
        out     dx,al   ; set bit mask so all bits are on
        inc     dx
        mov     al,0ffh
        out     dx,al
; now set the read guy up ok?
        mov     dx,3ceh
        mov     al,4    ; map mask
        out     dx,al
        inc     dx
        mov     al,2    ; bit plane 3
        out     dx,al
;       mov     al,08h ; bit mask index and all bits
;       mov     dx,3ceh
;       out     dx,al   ; set bit mask so all bits are on
;       inc     dx
;       mov     al,0ffh
;       out     dx,al
;       mov     dx,3ceh
;       mov     al,4    ; read map select register
;       out     dx,al
;       inc     dx
;       mov     al,4    ; bit plane
;       out     dx,al
        ret
set_write:
        mov     al,08h ; bit mask index and all bits
        mov     dx,3ceh
        out     dx,al   ; set bit mask so all bits are on
        inc     dx
        mov     al,0ffh
        out     dx,al
        mov     dx,3c4h ; sequencer
        mov     al,2    ; map mask
        out     dx,al
        mov     dx,3c5h
        mov     al,4  ; plane 3
        out     dx,al   ; set map to current guy
        ret



set10:
public set10
    cmp  deskv,0
    je   ok_deskv10
    ret
ok_deskv10:
    cmp   semaphore2,0
    je    oksem10
    ret
oksem10:
    push  es
    mov   ax,3510h  ; vid interrup
    int   21h
    mov   oint10,bx
    mov   oint10+2,es
    mov   ax,2510h
    lea   dx,int10
    int   21h
    pop   es
     ret

unset10:
  public unset10
    cmp  deskv,0
    je   ok_deskvu10
    ret
ok_deskvu10:
    cmp   semaphore2,0
    je    oksem10u
    ret
oksem10u:
    push  ds
    mov   ax,2510h
    mov   dx,oint10
    mov   ds,oint10+2
    int   21h
    pop   ds
    ret
;
set9:
public set9
    cmp  deskv,0
    je   ok_deskv
    ret
ok_deskv:
    cmp   semaphore2,0
    je    oksem9
    ret
oksem9:
    push  es
    mov   ax,3509h  ; kbd interrup
    int   21h
    mov   oint9,bx
    mov   oint9+2,es
    mov   ax,2509h
    lea   dx,int9
    int   21h
    pop   es
    ret
unset9:
public unset9
    cmp  deskv,0
    je   ok_deskv2
    ret
ok_deskv2:
    cmp   semaphore2,0
    je    oksem9u
    ret
oksem9u:
    push  ds
    mov   ax,2509h
    mov   dx,oint9
    mov   ds,oint9+2
    int   21h
    pop   ds
    ret
;
restore_pallette:
; here we restore the color pallette
    cmp  did_pallette,0
    je   use_default
    cmp  did_pallette,1
    je   use_color
use_dac:
    mov  ah,10h
    mov  al,12h
    mov  cx,256
    mov  bx,0
    mov  dx,offset pallette
    int  10h
    ret
use_color:
    mov  ah,10h
    mov  al,2
    mov  dx,offset pallette
    int  10h
    ret
use_default:
    ret
int10:
; enter here when palette is changed
    cmp  cs:semaphore,0
    jne  exit10
    cmp  cs:semaphore2,0
    jne  exit10
    cmp  ah,10h
    je   got_pallette
exit10:
    jmp   dword ptr cs:oint10
got_pallette:
    push ax
    push bx
    push cx
    push si
    push di
    push ds
    push es
    cmp   al,0
    je    one_color
    cmp   al,2
    je    all_color
    cmp   al,10h
    je    set_dac
    cmp   al,12h
    je    set_dac_all
exit_color:
    pop  es
    pop  ds
    pop  di
    pop  si
    pop  cx
    pop  bx
    pop  ax
    jmp   dword ptr cs:oint10
one_color:
; bh=color
; bl=0-16
    push cs
    pop  ds
    mov  al,bh
    mov  bh,0
    mov  pallette[bx],al
    mov  did_pallette,1   ; color
    jmp  exit_color
all_color:
; do 17 colors
    mov  cx,17
    mov  di,offset pallette
    push es
    pop  ds
    push cs
    pop  es
    mov  si,dx
    cld
rep movsb
    mov   es:did_pallette,1
    jmp  exit_color
set_dac:
    push cs
    pop  ds
    mov  ax,bx
    shl  bx,1
    add  bx,ax
    mov  pallette[bx],dh
    mov  pallette[bx]+1,ch
    mov  pallette[bx]+2,cl
    mov  did_pallette,2   ; dac
    jmp  exit_color
set_dac_all:
    mov  di,offset pallette
    push es
    pop  ds
    push cs
    pop  es
    mov  si,bx
    shl  si,1
    add  si,bx
    add  di,bx  ; starting dac
    mov  si,dx
    mov  ax,cx
    shl  ax,1
    add  cx,ax  ; mul by three
    cmp  cx,256*3
    ja   by_move
    cld
rep movsb
    mov  es:did_pallette,2   ; dac
by_move:
    jmp  exit_color


;
;
bscreen:
; this sets up the boss screen
;
   mov   cs:savess,ss
   mov   cs:savesp,sp
   mov   ax,cs
   mov   ss,ax
   mov   sp,offset istack+510
   push  bx
   push  cx
   push  dx
   push  bp
   push  si
   push  di
   push  ds
   push  es
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
;
   call  blip
;
; check for video mode, can only switch if in text or a ega/vga graph
   mov   ah,15
   int   10h
   and   al,7fh
; check_good modes
   cmp   al,13h
   ja    nogood_modes
   cmp   al,11
   je    nogood_modes
   cmp   al,12
   je    nogood_modes
   mov   old_mode,al
   cmp   al,3
   jbe   save_text
   cmp   al,7
   je    save_text
   jb    save_cga
   jmp   save_graph
nogood_modes:
   jmp   exit_boss2
save_graph:
; this is the EGA VGA stuff. We have to enable the read mode
; to get the first plane only
   call  resetres
   call  swap_screen
   mov   ah,0
   mov   al,83h
   int   10h
   call  swap_screent
   call  showfake
   call  swap_screent
   mov   ah,0
   mov   al,old_mode
   or    al,80h
   int   10h
   call  restore_pallette
   call  unswap_screen
;  call  retcurs
   jmp   exit_boss
save_text:
   call  resetres
   call  getcurs
   call  swap_screent
   call  showfake
   call  swap_screent
   call  retcurs
;
;
;
;
exit_boss:
   call  unresetres
exit_boss2:
   call  blop
;
   pop   es
   pop   ds
   pop   di
   pop   si
   pop   bp
   pop   dx
   pop   cx
   pop   bx
   mov   ss,cs:savess
   mov   sp,cs:savesp
   ret
save_cga:
; here we have to save a cga screen
; we do save before swap
   call  resetres
   call  swap_screent
   mov   ah,0
   mov   al,83h
   int   10h
   call  showfake
   mov   ah,0
   mov   al,old_mode
   or    al,80h
   int   10h
   call  swap_screent
;  call  retcurs
   call  restore_pallette
   jmp   exit_boss

swap_screent:
   push  es
   push  cs
   pop   es
   mov   cx,2000
   mov   si,offset screen
   mov   di,0
   mov   es,vbuff
stt_loop:
   cld
   lodsw
   xchg  word ptr es:[di],ax
   mov   word ptr ds:[si]-2,ax
   inc   di
   inc   di
   loop  stt_loop
   pop   es
   ret

;

swap_screen:
; this saves the video to fontsave
   call  set_read
   push  ds
   push  es
   push  cs
   pop   es
   mov   cx,8400
   mov   di,offset fontsave
   mov   si,0
   mov   ax,0a000h
   mov   ds,ax
ss1_loop:
   call  set_read
   cld
   movsb
   loop  ss1_loop
   pop   es
   pop   ds
   ret


unswap_screen:
   call  set_write
; this saves the screen to video there must be read before write
   push  es
   push  cs
   pop   ds
   mov   cx,8400
   mov   si,offset fontsave
   mov   di,0
   mov   ax,0a000h
   mov   es,ax
us_loop:
   lodsb
   mov   bl,byte ptr es:[di]
   stosb
   loop  us_loop
   pop   ds

        mov     al,08h ; bit mask index and all bits
        mov     dx,3ceh
        out     dx,al   ; set bit mask so all bits are on
        inc     dx
        mov     al,0ffh
        out     dx,al
        mov     dx,3c4h ; sequencer
        mov     al,2    ; map mask
        out     dx,al
        mov     dx,3c5h
        mov     al,0ffh; plane 3
        out     dx,al   ; set map to current guy
   ret
blip    proc  near
public blip
        push  si
        mov   si,20
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
public blop
        push  si
        mov   si,-20
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,100  ; starting freq
        mov   cx,900  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,900  ; starting freq
        mov   cx,100  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:
        nop
        nop
        nop
	loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp

;
int9:
public int9
; looking for hotkey
    push  ax
    mov   al,1
lock xchg cs:semaphore,al
    cmp  al,0
    jne   no_alt_ls
    cmp  cs:semaphore2,0
    jne  no_alt_ls
    mov   ah,2
    int   16h
    and   al,cs:hshift
    cmp   al,cs:hshift
    jne   no_alt_ls2
; find out what the key is
    in    al,60h   ; kbd data
;   and   al,7fh
    cmp   al,cs:hscan
    jne   no_alt_ls2
; have got it
    push  dx
    in    al,61h
    jmp   $+2
    jmp   $+2
    mov   ah,al
    or    al,80h
    mov   dx,61h
    out   dx,al
    jmp   $+2
    jmp   $+2
    mov   al,ah
    out   dx,al
    jmp   $+2
    jmp   $+2
    mov   al,20h
    mov   dx,20h
    out   dx,al
    pop   dx
    cli
    call  bscreen
    mov   cs:semaphore,0
    pop   ax
    iret
no_alt_ls2:
    mov   cs:semaphore,0
no_alt_ls:
    pop   ax
    jmp   dword ptr cs:oint9
unresetres:
    cmp   deskv,0
    je    usres1
    ret
usres1:
    push  ax
    push  cx
    push  si
    push  di
    push  ds
    push  es
    push  cs
    pop   ds
    mov   di,0
    mov   ax,0
    mov   es,ax
    mov   cx,512
    mov   si,offset  oldints
    cld
rep movsw
    pop   es
    pop   ds
    pop   di
    pop   si
    pop   cx
    pop   ax
    ret
resetres:
public resetres
    cmp   deskv,0
    je    rrres1
    ret
rrres1:
    push  ax
    push  cx
    push  si
    push  di
    push  ds
    push  es
    push  ds
    push  es
    push  cs
    pop   es
    mov   si,0
    mov   ax,0
    mov   ds,ax
    mov   cx,512
    mov   di,offset oldints
    cld
rep movsw
    pop   es
    pop   ds
    push  cs
    pop   ds
    mov   di,0
    mov   ax,0
    mov   es,ax
    mov   cx,512
    mov   si,offset  allints
    cld
rep movsw
    pop   es
    pop   ds
    pop   di
    pop   si
    pop   cx
    pop   ax
    ret
unsetres:
public unsetres
    cmp   deskv,0
    je    urres1
    ret
urres1:
    push  ax
    push  cx
    push  si
    push  di
    push  ds
    push  es
    push  cs
    pop   ds
    mov   di,0
    mov   ax,0
    mov   es,ax
    mov   cx,512
    mov   si,offset  allints
    cld
rep movsw
    pop   es
    pop   ds
    pop   di
    pop   si
    pop   cx
    pop   ax
    ret
setres:
public setres
; get all of the interrupts
    mov   ah,15
    int   10h
    mov   mode,al
    cmp   deskv,0
    je    ssres1
    ret
ssres1:
    push  ax
    push  cx
    push  si
    push  di
    push  ds
    push  es
    push  cs
    pop   es
    mov   si,0
    mov   ax,0
    mov   ds,ax
    mov   cx,512
    mov   di,offset allints
    cld
rep movsw
    pop   es
    pop   ds
    pop   di
    pop   si
    pop   cx
    pop   ax
    ret
setres  proc  near
; get the printer interrupt
startres:
        mov   ax,3527h
        int   21h
        mov   int27cs,es
        mov   int27ip,bx
        mov   ah,25h
        mov   al,27h
        lea   dx,resident
        int   21h
        lea   dx,startres
        int 27h
setres  endp
CSEG ends
        END        ENTPT
